package com.rusefi.io;

import com.rusefi.io.serial.SerialPortReader;
import jssc.SerialPort;
import jssc.SerialPortException;
import com.opensr5.io.DataListener;
import java.nio.ByteBuffer;

public class TwoWayTester {

//    private static final int BAUD_RATE = 38400;
    private static final int BAUD_RATE = 115200;
    //public static final String TEST_LINE = "a0123456789b0123456789c0123456789d0123456789e0123456789f0123456789g0123456789h0123456789d0123456789";
//    public static final String TEST_LINE = "a0123456789b0123456789";
	  public static String TEST_LINE;
	  public static int num = 20;
	  public static byte [] data = new byte [num];
/*    public static final DataListener VOID = new DataListener() {
        @Override
        public void onDataArrived(byte freshData[]) {
            // nothing is expected to arrive
        }
    };
*/

    public static int offs = 97;

    public static void main(String[] args) throws SerialPortException, InterruptedException {
        if(args.length<1) {
            System.out.println("Parameter expected");
        }


        String port1 = args[0];
        //String port1 = "COM4";

        DataListener listener = new DataListener() {

            int counter = 0;
            int total = 0;
            StringBuffer sb = new StringBuffer();

            @Override
            public void onDataArrived(byte freshData[]) {
                String string = new String(freshData);
                sb.append(string);
                if (sb.length() < TEST_LINE.length()) {
                    logLine("Partial");
                    return;
                }
                

                String l = sb.substring(0, TEST_LINE.length());

                if (!l.equalsIgnoreCase(TEST_LINE)) {
                    logLine("FAIL WOW   " + l);
                    logLine("FAIL not   " + TEST_LINE);

                    int index = sb.indexOf(TEST_LINE.charAt(0) + "", 1);
                    if (index != -1)
                        sb.delete(0, index);

                } else {
                    logLine("Ok " + counter + " / " + total);
                    sb.delete(0, TEST_LINE.length());
                    counter++;
                }

                total++;
            }
        };
        //SerialPort in = open(port2, listener);


        SerialPort out = open(port1, listener);
        if (out == null)
        	return;

        while (true) {
        	logLine("!"+offs);
        	for (int i = 0; i < num; i++)
        	{
        		data[i] = (byte)((i + offs) & 0xff);
        	}
            out.writeBytes(data);
        	TEST_LINE = new String(data);
        	//Thread.sleep(300);
            Thread.sleep(50);
            //offs++;
        }
    }

    public static SerialPort open(String port, DataListener listener) throws SerialPortException {
        SerialPort serialPort = new SerialPort(port);
        logLine("Opening " + port + " @ " + BAUD_RATE);
        boolean opened = serialPort.openPort();//Open serial port
        if (!opened)
        {
            logLine("not opened");
            return null;
        }
        serialPort.setParams(BAUD_RATE, 8, 1, 0);//Set params.
        int mask = SerialPort.MASK_RXCHAR;
        //Set the prepared mask
        serialPort.setEventsMask(mask);
        SerialPortReader reader = new SerialPortReader(serialPort, listener);
        serialPort.addEventListener(reader.getSerialPortEventListener());
        return serialPort;
    }

    private static void logLine(String s) {
        System.out.println(s);
    }
}
